function [K,Ff,T]=Create_TKF(E,G,I,J,LX,LZ,Qf)
% The input parameters are E, G, I, J, LX, LZ, and Qf. 
% The outputs are K, Ff, T.  
% Order of input parameters must be identical here and in the main program.

L=sqrt(LX^2+LZ^2);
c=LX/L;     % cosine
s=LZ/L;     % sine


k=E*I/L^3*[
      12               0   6*L       -12               0   6*L
       0   G*J*L^2/(E*I)     0         0  -G*J*L^2/(E*I)     0
     6*L               0 4*L^2      -6*L               0 2*L^2
     -12               0  -6*L        12               0  -6*L
       0  -G*J*L^2/(E*I)     0         0   G*J*L^2/(E*I)     0 
     6*L               0 2*L^2      -6*L               0 4*L^2]

T=[
 1  0  0  0  0 0
 0  c  s  0  0 0 
 0 -s  c  0  0 0
 0  0  0  1  0 0
 0  0  0  0  c s
 0  0  0  0 -s c];   

Ff=T'*Qf;

K=T'*k*T;