% Grid MATLAB Code with Member Loads - HW6
% Units: Kilonewtons (kN) and Millimeters (mm)

clc     %Clear the window
clear   %Clear the memory

% This general format works well for most engineering problems
format short g

% Define the number of element dofs (always 6 for the frame element)
NEdof=6;

% Define the number of structural dofs
NSdof=3;

% Initialize {Pf} and [S]
P=zeros(NSdof,1);
Pf=zeros(NSdof,1);
S=zeros(NSdof,NSdof);

E=200;
G=76;

%Define nonzero terms in P

P(1)=-12;

% Define the code numbers
CodeNum=[
 4  5  6 1 2 3
 1  2  3 7 8 9
10 11 12 1 2 3] % Here we write out each row explicitly

% Define geometry and loading for each member, create the member stiffness and fixed-end-force vectors
% and then assemble {Pf} and [S]. Note that no units are shown, you just need to
% be consistent.

MemNum=1;
Qf1=zeros(NEdof,1);

r=150;  % radius in mm
I=pi*r^4/4;   % circular cross-section
J=pi*r^4/2;   % circular cross-section

LX=8e3;     % sign (+/-) important
LZ=0;       % sign (+/-) important

L=sqrt(LX^2+LZ^2);

              % Fixed End Forces/Moments 
T=6*1000;     % Note: (+) Concentrated TORQUE assumed left

a=4000;
b=4000;

FSb=0;
FTb=T*b/L;
FMb=0;
FSe=0;
FTe=T*a/L;
FMe=0;

Qf1=[FSb;FTb;FMb;FSe;FTe;FMe];

Qf1

[K1,Ff1,T1]=Create_TKF(E,G,I,J,LX,LZ,Qf1)
[S,Pf]=Assemble_S_Pf(S,K1,Pf,Ff1,MemNum,NEdof,NSdof,CodeNum);


MemNum=2;
Qf2=zeros(NEdof,1);

r=150;  % radius in mm
I=pi*r^4/4;   % circular cross-section
J=pi*r^4/2;   % circular cross-section

LX=0;       % sign (+/-) important
LZ=-6e3;    % sign (+/-) important

L=sqrt(LX^2+LZ^2);

            % Fixed End Forces/Moments 
W=8;        % Note: (+) Concentrated FORCE assumed down

FSb=W/2;
FTb=0;
FMb=W*L/8;
FSe=W/2;
FTe=0;
FMe=-W*L/8;

Qf2=[FSb;FTb;FMb;FSe;FTe;FMe];

Qf2

[K2,Ff2,T2]=Create_TKF(E,G,I,J,LX,LZ,Qf2)

[S,Pf]=Assemble_S_Pf(S,K2,Pf,Ff2,MemNum,NEdof,NSdof,CodeNum);


MemNum=3;
Qf3=zeros(NEdof,1);

r=150;  % radius in mm
I=pi*r^4/4;   % circular cross-section
J=pi*r^4/2;   % circular cross-section

LX=8e3;    % sign (+/-) important
LZ=6e3;    % sign (+/-) important

L=sqrt(LX^2+LZ^2);

Qf3

[K3,Ff3,T3]=Create_TKF(E,G,I,J,LX,LZ,Qf3)

[S,Pf]=Assemble_S_Pf(S,K3,Pf,Ff3,MemNum,NEdof,NSdof,CodeNum);

%***************** SOLVE *****************

% Solve for displacements (note the use of the backslash operator instead
% of the inv command. We could have used d=inv(S)*(P-Pf), or even
% d=S^-1*(P-Pf), but the backslash approach is much more efficient.)

P
Pf
S

d=S\(P-Pf)


%************** POST-PROCESS *************

% Use compatibility to create the {v} vectors for each element
v1=[0; 0; 0; d(1); d(2); d(3)];
v2=[d(1); d(2); d(3); 0; 0; 0];
v3=[0; 0; 0; d(1); d(2); d(3)];

% Calculate the member end forces (global)
F1=Ff1+K1*v1
F2=Ff2+K2*v2
F3=Ff3+K3*v3

% Calculate the member end forces (local)
Q1=T1*F1
Q2=T2*F2
Q3=T3*F3

% Calculate the support reactions
R4=F1(1)
R5=F1(2)
R6=F1(3)

R7=F2(4)
R8=F2(5)
R9=F2(6)  

R10=F3(1)
R11=F3(2)
R12=F3(3)

